package ch.kri.fhbb.Reflection;

import java.awt.*;
import javax.swing.*;
import java.lang.reflect.*;
import java.util.*;

public class Reflection extends javax.swing.JFrame {
    public Reflection() {
        initComponents();
        
        // Initialize a few GUI components
        cmbConstructor.addItem(new Integer(0));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelClass = new javax.swing.JPanel();
        btnAnalyze = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        txtClassName = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtAnalysis = new javax.swing.JTextPane();
        panelObjects = new javax.swing.JPanel();
        cmbConstructor = new javax.swing.JComboBox();
        txtConstructorParameters = new javax.swing.JTextField();
        btnCreateObject = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        txtObjectInfo = new javax.swing.JTextPane();
        panelTest = new javax.swing.JPanel();
        panelErrors = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtErrors = new javax.swing.JTextPane();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setTitle("Reflection");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        panelClass.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        panelClass.setBorder(new javax.swing.border.TitledBorder("Class information"));
        btnAnalyze.setText("Analyze");
        btnAnalyze.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAnalyzeActionPerformed(evt);
            }
        });
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 2;
        gridBagConstraints2.gridy = 0;
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
        panelClass.add(btnAnalyze, gridBagConstraints2);
        
        jLabel1.setText("Class to load: ");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 0;
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        panelClass.add(jLabel1, gridBagConstraints2);
        
        txtClassName.setPreferredSize(new java.awt.Dimension(400, 21));
        txtClassName.setMinimumSize(new java.awt.Dimension(150, 21));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelClass.add(txtClassName, gridBagConstraints2);
        
        jScrollPane1.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(600, 400));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(400, 200));
        txtAnalysis.setPreferredSize(new java.awt.Dimension(6, 6));
        txtAnalysis.setMinimumSize(new java.awt.Dimension(400, 200));
        jScrollPane1.setViewportView(txtAnalysis);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.gridwidth = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        panelClass.add(jScrollPane1, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(panelClass, gridBagConstraints1);
        
        panelObjects.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        panelObjects.setBorder(new javax.swing.border.TitledBorder("Object information"));
        panelObjects.setPreferredSize(new java.awt.Dimension(610, 452));
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
        panelObjects.add(cmbConstructor, gridBagConstraints3);
        
        txtConstructorParameters.setPreferredSize(new java.awt.Dimension(400, 21));
        txtConstructorParameters.setMinimumSize(new java.awt.Dimension(150, 21));
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelObjects.add(txtConstructorParameters, gridBagConstraints3);
        
        btnCreateObject.setLabel("Create");
        btnCreateObject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCreateObjectActionPerformed(evt);
            }
        });
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
        panelObjects.add(btnCreateObject, gridBagConstraints3);
        
        jScrollPane3.setPreferredSize(new java.awt.Dimension(600, 400));
        jScrollPane3.setMinimumSize(new java.awt.Dimension(400, 200));
        txtObjectInfo.setPreferredSize(new java.awt.Dimension(6, 6));
        txtObjectInfo.setMinimumSize(new java.awt.Dimension(400, 200));
        jScrollPane3.setViewportView(txtObjectInfo);
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.gridy = 1;
        gridBagConstraints3.gridwidth = 3;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        panelObjects.add(jScrollPane3, gridBagConstraints3);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(panelObjects, gridBagConstraints1);
        
        panelTest.setBorder(new javax.swing.border.TitledBorder("Testing pane"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(panelTest, gridBagConstraints1);
        
        panelErrors.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints4;
        
        panelErrors.setBorder(new javax.swing.border.TitledBorder("Errors"));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(600, 200));
        jScrollPane2.setMinimumSize(new java.awt.Dimension(400, 100));
        txtErrors.setPreferredSize(new java.awt.Dimension(6, 6));
        txtErrors.setMinimumSize(new java.awt.Dimension(400, 100));
        jScrollPane2.setViewportView(txtErrors);
        
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;
        panelErrors.add(jScrollPane2, gridBagConstraints4);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(panelErrors, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        pack();
    }//GEN-LAST:event_formComponentResized

    private void btnCreateObjectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCreateObjectActionPerformed
        try {
            int constNum = ( (Integer) cmbConstructor.getSelectedItem() ).intValue();
            Constructor tmpConstructor = aClassConstructors[constNum];
            Class[] tmpParameterTypes = aClassConstructors[constNum].getParameterTypes();
            Object[] tmpParameters = new Object[tmpParameterTypes.length];
            
            // Now parse the parameters we were given
            boolean paramsOK = true;
            StringTokenizer t = new StringTokenizer(txtConstructorParameters.getText(), ",");
            int numParameters = t.countTokens();
            if (numParameters != tmpParameters.length) {
                txtErrors.setText(txtErrors.getText() + "\nWrong number of parameters");
            } else {
                // Construct the parameter list from what the user entered. For each parameter
                // we find a constructor that takes a String, and invoke it.
                Class[] pParamTypes = new Class[] { Class.forName("java.lang.String") };
                for (int i = 0; i < numParameters; i++) {
                    try {
                        if (tmpParameterTypes[i].getName() == "int") {
                            tmpParameterTypes[i] = java.lang.Class.forName("java.lang.Integer");
                        } else if (tmpParameterTypes[i].getName() == "float") {
                            tmpParameterTypes[i] = java.lang.Class.forName("java.lang.Float");
                        }
                        
                        // constructor for this parameter
                        Constructor pConstructor = tmpParameterTypes[i].getConstructor(pParamTypes);
                        
                        // parameter for the constructor is the next token
                        Object[] pParams = new Object[] { t.nextToken() };
                        
                        // call constructor to create parameter
                        tmpParameters[i] = pConstructor.newInstance(pParams);
                    }
                    catch (NoSuchMethodException e) {
                        txtErrors.setText(txtErrors.getText() + "\nCannot construct " + getTypeString(tmpParameterTypes[i]) + " from String");
                        paramsOK = false;
                    }
                }
                if (paramsOK) {
                    // We now have the parameters, so we can invoke the selected constructor  
                    aInstance = tmpConstructor.newInstance(tmpParameters);
                    txtErrors.setText(txtErrors.getText() + "\nObject created");
                } else {
                    aInstance = null;
                }
                getObjectInfo();
            }
        }
        catch (Exception e) {
            txtErrors.setText(txtErrors.getText() + "\n" + e.toString());
        }
    }//GEN-LAST:event_btnCreateObjectActionPerformed

    // Information about a class
    private Class aClass;
    private String aClassName;
    private String aClassSuperclass;
    private String aClassPackage;
    private Constructor[] aClassConstructors;
    private Field[] aClassProperties;
    private Method[] aClassMethods;
    
    // Information about a constructed instance of a class
    private Object aInstance;

    private void btnAnalyzeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAnalyzeActionPerformed
        String tmpString;

        try {
            txtAnalysis.setText("");
            txtErrors.setText("");
            aClass = Class.forName(txtClassName.getText());
            
            // Important names
            aClassName = aClass.getName();
            aClassSuperclass = aClass.getSuperclass().getName();
            aClassPackage = aClass.getPackage().getName();
            
            txtAnalysis.setText("Package " + aClassPackage + ": class " + aClassName + 
                                  " extends " + aClassSuperclass + "\n\n" );
            
            // Constructors
            aClassConstructors = aClass.getDeclaredConstructors();
            tmpString = "Constructors\n";
            for (int i = 0; i < aClassConstructors.length; i++) {
                tmpString += Integer.toString(i) + ": ";
                String name = aClassConstructors[i].getName();
                int modifiers = aClassConstructors[i].getModifiers();
                Class[] parameterTypes = aClassConstructors[i].getParameterTypes();
                Class[] exceptionTypes = aClassConstructors[i].getExceptionTypes();
                
                tmpString += getModifierString( modifiers );
                tmpString += name;
                tmpString += getParameterString(parameterTypes);
                tmpString += getExceptionString(exceptionTypes);
                tmpString += "\n";
            }
            txtAnalysis.setText(txtAnalysis.getText() + tmpString);
            
            // Fill the combo, from which we select a constructor to use...
            while (cmbConstructor.getItemCount() > 0) cmbConstructor.removeItemAt(0);
            for (int i = 0; i < aClassConstructors.length; i++) {
                cmbConstructor.addItem(new Integer(i));
            }
            
            // Class properties
            Field[] aClassFields = aClass.getDeclaredFields();
            tmpString = "\nFields\n";
            for (int i = 0; i < aClassFields.length; i++) {
                int modifiers = aClassFields[i].getModifiers();
                String typeName = getTypeString(aClassFields[i].getType());
                String name = aClassFields[i].getName();
                tmpString += Integer.toString(i) + ": ";
                tmpString += getModifierString(modifiers) + typeName + " " + name + "\n";
            }
            txtAnalysis.setText(txtAnalysis.getText() + tmpString);
            
            // Class methods
            Method[] aClassMethods = aClass.getDeclaredMethods();
            tmpString = "\nMethods\n";
            for (int i = 0; i < aClassMethods.length; i++) {
                int modifiers = aClassMethods[i].getModifiers();
                String returnTypeName = getTypeString(aClassMethods[i].getReturnType());
                String name = aClassMethods[i].getName();
                
                Class[] parameterTypes = aClassMethods[i].getParameterTypes();
                String parameterNames = getParameterString(parameterTypes);

                Class[] exceptionTypes = aClassMethods[i].getExceptionTypes();
                String exceptionNames = getExceptionString(exceptionTypes);

                tmpString += Integer.toString(i) + ": ";
                tmpString += getModifierString(modifiers) + returnTypeName + name;
                tmpString += parameterNames + exceptionNames + "\n";
            }
            txtAnalysis.setText(txtAnalysis.getText() + tmpString);
        }
        catch (Exception e) {
            txtErrors.setText(txtErrors.getText() + "\n" + e.toString());
        }
    }//GEN-LAST:event_btnAnalyzeActionPerformed

    private String getModifierString(int modifiers) {
        String tmpString = "";

        if (Modifier.isAbstract(modifiers)) tmpString += "abstract ";
        if (Modifier.isFinal(modifiers)) tmpString += "final ";
        if (Modifier.isInterface(modifiers)) tmpString += "interface ";
        if (Modifier.isNative(modifiers)) tmpString += "native ";
        if (Modifier.isPrivate(modifiers)) tmpString += "private ";
        if (Modifier.isProtected(modifiers)) tmpString += "prptected ";
        if (Modifier.isPublic(modifiers)) tmpString += "public ";
        if (Modifier.isStatic(modifiers)) tmpString += "static ";
        if (Modifier.isStrict(modifiers)) tmpString += "strict ";
        if (Modifier.isSynchronized(modifiers)) tmpString += "synchronized ";
        if (Modifier.isTransient(modifiers)) tmpString += "transient ";
        if (Modifier.isVolatile(modifiers)) tmpString += "volatile ";
        return tmpString;
    }

    private String getParameterString(Class[] parameterTypes) {
        String tmpString;
        
        tmpString = "(";
        for (int j = 0; j < parameterTypes.length; j++) {
            if ( j > 0 ) tmpString += ", ";
            tmpString += getTypeString(parameterTypes[j]);
        }
        tmpString += ")";
        return tmpString;
    }
    
    private String getTypeString(Class tmpClass) {
        String tmpString = "";
        int Brackets=0;

        while (tmpClass.isArray()) {
            Brackets += 1;
            tmpClass = tmpClass.getComponentType();
        }
        tmpString += tmpClass.getName();
        for(int k = 0; k < Brackets; k++) {
            tmpString += "[]";
        }
        return tmpString;
    }
    
    private String getExceptionString(Class[] exceptionTypes) {
        String tmpString = "";

        for (int j = 0; j < exceptionTypes.length; j++) {
            if ( j == 0 ) tmpString += " throws ";
            if ( j > 0 ) tmpString += ", ";
            tmpString += exceptionTypes[j].getName();
        }
        return tmpString;
    }
    
    // Inspect the object stored in aInstance
    private void getObjectInfo() {
        String tmpString = "";
        
        if (aInstance == null) {
            tmpString = "Object is NULL";
        } else {
            tmpString = "Class = " + aInstance.getClass().getName();
            tmpString += "\nValue = " + aInstance.toString();
        }
        txtObjectInfo.setText(tmpString);
    }
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new Reflection().show();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel panelClass;
    private javax.swing.JButton btnAnalyze;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField txtClassName;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextPane txtAnalysis;
    private javax.swing.JPanel panelObjects;
    private javax.swing.JComboBox cmbConstructor;
    private javax.swing.JTextField txtConstructorParameters;
    private javax.swing.JButton btnCreateObject;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextPane txtObjectInfo;
    private javax.swing.JPanel panelTest;
    private javax.swing.JPanel panelErrors;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextPane txtErrors;
    // End of variables declaration//GEN-END:variables

}
